// ----------------------------------------------------
//		Copyright (C) 2014 by Focus Learning Corporation
//		All rights reserved.
//
//		This software is the confidential and proprietary information
//		of Focus Learning Corporation ("Confidential Information").
// ----------------------------------------------------

var grid, loadingIndicator;

// ----------------------------------------------------

$(document).ready(function () {
    //    ManualScoringInit();
    var data = [
            { "learnerId": 1, "hasExamScore": false, "lastName": "Brando", "firstName": "Marlon", "dateCompleted": "10/24/1989", "score": 79, "comments": "" },
            { "learnerId": 2, "hasExamScore": false, "lastName": "Damon", "firstName": "Matt", "dateCompleted": "12 / 24 / 1998", "score": 88, "comments": "" },
            { "learnerId": 3, "hasExamScore": true, "lastName": "Rockwell", "firstName": "Sam", "dateCompleted": "03 / 31 / 1988", "score": 62, "comments": "read-only" },
            { "learnerId": 4, "hasExamScore": false, "lastName": "Clooney", "firstName": "George", "dateCompleted": "06 / 10 / 2008", "score": 25, "comments": "" },
            { "learnerId": 316, "hasExamScore": false, "lastName": "Affleck", "firstName": "Ben", "dateCompleted": "11 / 05 / 1994", "score": 43, "comments": "" },
            { "learnerId": 317, "hasExamScore": false, "lastName": "Norton", "firstName": "Ed", "dateCompleted": "08 / 10 / 2011", "score": 45, "comments": "" },
            { "learnerId": 318, "hasExamScore": true, "lastName": "Hardy", "firstName": "Tom", "dateCompleted": "07 / 13 / 2002", "score": 76, "comments": "read-only" },
            { "learnerId": 319, "hasExamScore": false, "lastName": "De Niro", "firstName": "Robert", "dateCompleted": "11 / 24 / 2004", "score": 78, "comments": "" },
            { "learnerId": 320, "hasExamScore": false, "lastName": "Bale", "firstName": "Christian", "dateCompleted": "11 / 25 / 2014", "score": 68, "comments": "" }
        ];

    UpdateManualScoringData(data);


});


// ----------------------------------------------------

//function OnSaveChangesSuccess(Result) 
//{
//	loadingIndicator.hide();
//}

//function OnSaveChangesError(ex)
//{
//	loadingIndicator.hide();
//	DisplayError(ex.responseText);
//}

// ----------------------------------------------------

//function ManualScoringInit()
//{
//    DetectBrowser();

//	PostbackInfo.CustomGetPostbackInfo = false;
//    GetPostbackInfo(OnManualScoringPostbackInfo);
//}

// ----------------------------------------------------

function InitDefaultsGrid() {

    var dateObject = new Date();

    var ds = [
            { "pk": 1, "defaultDate": dateObject, "defaultScore": "100" }
        ];

    $("#unscoredDefaultsGrid").igGrid({
        primaryKey: "pk",
        columns: [
                { headerText: "pk", key: "pk", dataType: "number", width: 0, hidden: true },
                { headerText: "Default Completion Date", key: "defaultDate", dataType: "date", width: 140 },
                { headerText: "Default Score", key: "defaultScore", dataType: "number", width: 80 }
        ],

        dataSource: ds,
        dataRendered: function (evt, ui) {
            ui.owner.element.find("tr td:nth-child(1)").css("text-align", "center");
            ui.owner.element.find("tr td:nth-child(2)").css("text-align", "center");
        },
        features: [
            {
                name: "Updating",
                enableAddRow: false,
                editMode: "row",
                enableDeleteRow: false,
                columnSettings: [
                    { columnKey: "defaultDate", editorType: "datepicker", required: true },
                    { columnKey: "defaultScore", editorType: "numeric", required: true, dataMode: "int",
                        editorOptions: {
                            button: "spin",
                            minValue: 0,
                            maxValue: 100
                        }
                    },
                ]
            }]
    });
}


//function OnManualScoringPostbackInfo(xmlText)
//{
//	OnPostbackInfo(xmlText);

//	ExecPostbackForId("GetData");
//}

// ----------------------------------------------------

function InitIgUI()
{
	grid = $("#grid");
	//loadingIndicator = new GridModalLoadingIndicator(grid);

	$("#saveChanges").igButton({ labelText: $("#saveChanges").val(), disabled: true });
	$("#saveChanges").on('igbuttonclick', OnSaveChangesClick);

	$("#undo").igButton({ labelText: $("#undo").val(), disabled: true });
	$("#undo").on('igbuttonclick', OnUndoClick);

	$("#redo").igButton({ labelText: $("#redo").val(), disabled: true });
	$("#redo").on('igbuttonclick', OnRedoClick);

	$("#btnDefaultsAll").igButton({ labelText: $("#btnDefaultsAll").val(), disabled: false });

	grid.on("iggridupdatingeditrowended", function (e, args) {
	    if (args.update) {
	        $("#undo").igButton("option", "disabled", false);
	        $("#saveChanges").igButton("option", "disabled", false);
	    }
	});

	$("#btnDefaultsAll").on("igbuttonclick", function () {

	    var rowsLength = $("#grid").igGrid("allRows").length;

	    for (var i = 0; i < rowsLength; i++) {
	        var row = $("#grid").igGrid("rowAt", i);
	        var rowID = parseFloat($(row).attr("data-id"));
	        var hasExamScore = $("#grid").igGrid("getCellValue", rowID, "hasExamScore");

	        if (!hasExamScore) { 
	            $("#grid").igGridUpdating("setCellValue", rowID, "dateCompleted", GetDefaultDate());
	            $("#grid").igGridUpdating("setCellValue", rowID, "score", GetDefaultScore());
            }
	    }

	    $("#undo").igButton("option", "disabled", false);
	    $("#saveChanges").igButton("option", "disabled", false);

	});

	InitDefaultsGrid();
}

// ----------------------------------------------------

function UpdateManualScoringData(data)
{
	try
	{
	    $("#grid").igGrid({
	        primaryKey: "learnerId",
	        height: "400px",
	        columns: [
                { headerText: "LearnerId", key: "learnerId", dataType: "number", template: "${learnerId}", width: 40, hidden: true },
            //    { headerText: "EventId", key: "eventId", dataType: "number", template: "${eventId}", width: 40, hidden: true },
            //    { headerText: "LessonId", key: "lessonId", dataType: "number", template: "${lessonId}", width: 40, hidden: true },
                { headerText: "HasExamScore", key: "hasExamScore", dataType: "bool", template: "${hasExamScore}", width: 40, hidden: true },
                { headerText: "Last Name", key: "lastName", dataType: "string", template: "${lastName}", width: 130 },
                { headerText: "First Name", key: "firstName", dataType: "string", template: "${firstName}", width: 130 },
                { headerText: "Date Completed", key: "dateCompleted", dataType: "date", template: "${dateCompleted}", width: 120 },
                { headerText: "Score", key: "score", dataType: "string", template: "${score}", width: 80 },
                { headerText: "Comments", key: "comments", dataType: "string", template: "${comments}", width: 270 },
            ],
	        autoGenerateColumns: false,
	        dataSource: data,
	        dataRendered: function (evt, ui) {
	            ui.owner.element.find("tr td:nth-child(3)").css("text-align", "center");
	            ui.owner.element.find("tr td:nth-child(4)").css("text-align", "center");
	        },

//            // Render read-only rows
//            rowsRendered: function (evt, ui) {
//                for (var i = 0; i < ui.owner.rows().length; i++) {
//                    var record = $("#grid").data("igGrid").options.dataSource[i];
//                    if (record.hasExamScore == true) {
//                        var rowId = $(ui.owner.rowAt(i)).attr("data-id");
//                        $("#grid").igGridUpdating("setCellValue", parseInt(rowId, 10), "score", "EXEMPT"); //record.score + " *");
//                    }
//                }
//            },
	        features: [
            {
                name: "Updating",
                enableAddRow: false,
                enableDeleteRow: false,
                editMode: "row",
                responseDataKey: "results",
                columnSettings: [
                    { columnKey: "lastName", readOnly: true },
                    { columnKey: "firstName", readOnly: true },
                    { columnKey: "dateCompleted", editorType: "datepicker", required: true },
                    { columnKey: "score", editorType: "numeric", required: true, dataMode: "int",
                        editorOptions: {
                            button: "spin",
                            minValue: 0,
                            maxValue: 100
                                        }
                                    },
                                ],
                editRowStarting: function (evt, ui) {
                    var rowId = ui.rowID;
                    var hasScore = $("#grid").igGrid("getCellValue", rowId, "hasExamScore");
                    if (hasScore == true)
                        evt.preventDefault();

//                    //populate cells onFocus
//                    data = $("#grid").data('igGrid').dataSource;
//                    data.setCellValue(rowId, "dateCompleted", GetDefaultDate(), true);
//                    data.setCellValue(rowId, "score", GetDefaultScore(), true);
                },
                editRowStarted: function (evt, ui) {
                    $(".ui-iggrid-buttoncontainer").css("margin-left", "320px");
                    rowIndex = ui.rowID;
                    defaultDate = GetDefaultDate();
                    defaultScore = GetDefaultScore();
                    var defaultRowValues = { "dateCompleted": defaultDate, "score": defaultScore };
                    // inserts DOm element via .append method
                    if ($("#btnApplyDefaults").length == 0) {
                        $(".ui-iggrid-buttoncontainer").append("<span id='btnApplyDefaults'></span>");
                        $("#btnApplyDefaults").addClass("ui-iggrid-button ui-state-default ui-corner-all");
                        $("#btnApplyDefaults").append("<span style='display: inline-block; padding: 3px 10px 5px 10px;'>Apply Defaults</span>")
                    }
                    // updates the row with predefined values that are holded in the rowValues object
                    $("#btnApplyDefaults").on("click", function () {
                        $("#grid").igGridUpdating("updateRow", rowIndex, defaultRowValues);
                    });

                    var removeRowValues = { "dateCompleted": "", "score": "" };

                    if ($("#btnRemoveScore").length == 0) {
                        $(".ui-iggrid-buttoncontainer").append("<span id='btnRemoveScore'></span>");
                        $("#btnRemoveScore").addClass("ui-iggrid-button ui-state-default ui-corner-all");
                        $("#btnRemoveScore").append("<span style='display: inline-block; padding: 3px 10px 5px 10px;'>Remove Score</span>")
                    }
                    // updates the row with predefined values that are holded in the rowValues object
                    $("#btnRemoveScore").on("click", function () {
                        $("#grid").igGridUpdating("updateRow", rowIndex, removeRowValues);
                    });

                }

            }]
	    });


		InitIgUI();
	}
	catch (ex)
	{
		DisplayError("UpdateManualScoringData() : " + ex.Message, IsDebug());
	}

}

function GetDefaultDate() {
    var defaultDate = $('#unscoredDefaultsGrid').find('tr:first').find('td:first').text();
    return defaultDate;
}

function GetDefaultScore() {
    defaultScore = $('#unscoredDefaultsGrid').find('tr:first').find('td:nth-child(2)').text();
    return defaultScore;
}

// ----------------------------------------------------
// ----------------------------------------------------

function OnSaveChangesClick(e) {
    grid.igGrid("saveChanges", OnSaveChangesSuccess, OnSaveChangesError);

    loadingIndicator.show();
    $("#undo").igButton("disable");
    $(this).igButton("disable");
    return false;
}

// ----------------------------------------------------

function OnRedoClick(e) {
    $.each(updates, function (index, transaction) {
switch (transaction.type) {
    case "cell":
        grid.igGridUpdating('setCellValue', transaction.rowId, transaction.col, transaction.value);
        break;

    case "row":
        grid.igGridUpdating('updateRow', transaction.rowId, transaction.row, null, false);
        break;
}

    });
    $(this).igButton("disable");
    $("#undo").igButton("option", "disabled", false);
    $("#saveChanges").igButton("option", "disabled", false);
}

// ----------------------------------------------------

function OnUndoClick(e) {
    updates = $.extend({}, grid.data('igGrid').pendingTransactions());
    $.each(updates, function (index, transaction) {
        grid.igGrid("rollback", transaction.rowId, true);
    });

    $("#redo").igButton("option", "disabled", false);
    $("#undo").igButton("disable");
    $("#saveChanges").igButton("disable");

    columns = $("#grid").igGrid("option", "columns");
    $("#grid").igGrid("renderMultiColumnHeader", columns);

    return false;
}

// ----------------------------------------------------

